/* ledswitch_v2
 *    
 * Egy LED ki-bekacsolása nyomógomb segítségével:    
 * - Első (és minden páratlan) lenyomásra a piros LED világítson!    
 * - Második (és minden páros) lenyomásra a LED kialszik!   
 * A nyomógomb kezelésére egy kétállapotú véges állapotgépet használunk,   
 * melynek állapotjelzője a waitforpress változó. Ha true az értéke,   
 * akkor gomblenyomásra, ha false, akkor pedig felengedésre várunk.
 */

#define RED_LED 5                // D5-re van kötve a LED
#define G1      3                // D3-ra van kötve a nyomógomb

//Hardverfüggetlen rész (MSP430 Launchpad kártyán is futtatható!)
boolean led_state = false;       // Kezdetben a LED ki van kapcsolva
boolean waitforpress = true;     // Kezdetben lenyomásra várunk

void setup() {
  pinMode(RED_LED, OUTPUT);      // Legyen kimenet
  pinMode(G1, INPUT_PULLUP);     //Bemenet belső felhúzással
}

void loop() {
  if (waitforpress) {            // Ha lenyomásra várunk és
    if (!digitalRead(G1)) {      // Ha lenyomás történt...
      led_state = !led_state;    // Állapot átbillentése
      digitalWrite(RED_LED, led_state);  // LED állapot aktualizálás
      waitforpress = false;      // Következő stáció: felengedésre várunk
    }
  }
  else {                         // Ha felengedésre vártunk és
    if (digitalRead(G1)) {       // Ha felengedést észlelünk...
      waitforpress = true;       // Következő stáció: lenyomásra várunk
    }
  }
  delay(20);                     // Pergésmentesítő késleltetés
}
