/* tft_graph

 A TFT Graph mintapélda, némileg módosítva
 Az A0 analóg bemenetet mintavételezi 16 ms-onként
 és a mért értéket megjeleníti a grafikus kijelzőn.

 Módosítások: 2020, I. Cserny

 Created 15 April 2013 by Scott Fitzgerald

 http://www.arduino.cc/en/Tutorial/TFTGraph

 */

#include <TFT.h>  // Arduino LCD library
#include <SPI.h>

// pin definition for the Uno
#define cs   10
#define dc   9
#define rst  8

TFT TFTscreen = TFT(cs, dc, rst);

// position of the line on screen
int xPos = 0;

void setup() {
  TFTscreen.begin();    // initialize the display
  TFTscreen.background(0, 0, 100);
}

void loop() {
  // read the sensor and map it to the screen height
  int sensor = analogRead(A0);
  int drawHeight = map(sensor, 0, 1023, 0, TFTscreen.height());
  TFTscreen.stroke(250, 250, 250);
  TFTscreen.line(xPos, TFTscreen.height() - drawHeight, xPos, TFTscreen.height());

  // if the graph has reached the screen edge
  // erase the screen and start again
  if (xPos >= 128) {
    xPos = 0;
    TFTscreen.background(0,0,100);
  } else {
    // increment the horizontal position:
    xPos++;
  }

  delay(16);
}
